// Wild Magic Source Code
// David Eberly
// http://www.geometrictools.com
// Copyright (c) 1998-2007
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or (at
// your option) any later version.  The license is available for reading at
// either of the locations:
//     http://www.gnu.org/copyleft/lgpl.html
//     http://www.geometrictools.com/License/WildMagicLicense.pdf
//
// Version: 4.0.1 (2007/01/15)

#include "WClassDesc.h"
#include "Max9ToWm4.h"
#include "resource.h"
#include "WSceneExport.h"

Class_ID WClassDesc::ID(0x554dbc9c,0x8f17519);
WClassDesc WClassDesc::TheDescription;

//----------------------------------------------------------------------------
WClassDesc::WClassDesc ()
{
}
//----------------------------------------------------------------------------
int WClassDesc::IsPublic () 
{ 
    return TRUE; 
}
//----------------------------------------------------------------------------
void* WClassDesc::Create (BOOL) 
{ 
    return new WSceneExport; 
}
//----------------------------------------------------------------------------
const TCHAR* WClassDesc::ClassName () 
{ 
    return Max9ToWm4::ThePlugin.GetResourceString(IDS_CLASS_NAME); 
}
//----------------------------------------------------------------------------
SClass_ID WClassDesc::SuperClassID () 
{ 
    return SCENE_EXPORT_CLASS_ID; 
}
//----------------------------------------------------------------------------
Class_ID WClassDesc:: ClassID () 
{ 
    return ID;
}
//----------------------------------------------------------------------------
const TCHAR* WClassDesc::Category ()
{ 
    return Max9ToWm4::ThePlugin.GetResourceString(IDS_CATEGORY); 
}
//----------------------------------------------------------------------------
const TCHAR* WClassDesc::InternalName () 
{ 
    return Max9ToWm4::ThePlugin.GetResourceString(IDS_INTERNALNAME); 
}
//----------------------------------------------------------------------------
HINSTANCE WClassDesc::HInstance () 
{ 
    return Max9ToWm4::ThePlugin.GetInstance(); 
}
//----------------------------------------------------------------------------
